-- %SCRIPT_VERSION% = "9.0.0.6"
-- this statment is placed here in order not to obe executed by the configuration tool
DELIMITER GO

-- %VERSION_UPGRADE% = "8.5.9.4"
DROP FUNCTION IF EXISTS getdate;

GO

CREATE FUNCTION getdate() RETURNS datetime BEGIN RETURN now(); END;

GO

CREATE TABLE OSLOG_PARAMETER(ID int not null auto_increment, NAME nvarchar(50) not null unique, VAL nvarchar(250), primary key(ID));
CREATE TABLE OSSYS_BASIC_TYPE(ID nvarchar(50) NOT NULL, NAME nvarchar(50), primary key(ID) );
CREATE TABLE OSSYS_ESPACE_ENTITY(ID integer not null auto_increment, ESPACE_ID integer not null, ENTITY_ID integer not null, READ_ONLY tinyint(1) not null, MULTITENANT_VIEW tinyint(1), NAME nvarchar(50), primary key(ID) );
CREATE TABLE OSSYS_RECOMPILATION_ERROR_LOG(ID integer not null auto_increment, OML integer, `TYPE` nvarchar(50), MESSAGE nvarchar(1024), DETAIL nvarchar(1024), MODULE nvarchar(50), primary key(ID));
CREATE TABLE OSSYS_ENTITY(ID integer not null auto_increment, PHYSICAL_TABLE_NAME nvarchar(2000), NAME nvarchar(50) NOT NULL, ESPACE_ID integer null, EXTENSION_ID integer null, SS_KEY nvarchar(50) not null, MULTITENANT integer, MULTITENANT_VIEW integer, IS_ACTIVE tinyint(1), IS_SYSTEM tinyint(1), IS_EXTERNAL tinyint(1), PRIMARYKEY_SS_KEY nvarchar(50), DESCRIPTION nvarchar(2000), GENERATION integer default -1, primary key(ID));
CREATE TABLE OSSYS_REPORT_SLOWQUERY(ESPACE integer, QUERY nvarchar(500), TM integer, REPORTID integer);
CREATE TABLE OSSYS_DEVELOPER_EXTENSION(ID integer not null auto_increment, DEVELOPER_ID integer, EXTENSION_ID integer, SECURITY_LEVEL integer, primary key(ID));
CREATE TABLE OSSYS_REPORT_HOUR(`HOUR` integer, DISPLAY nvarchar(50));
CREATE TABLE OSSYS_ESPACE_VERSION_SIGNATURE(ID integer not null auto_increment, SIGNATURE mediumtext, SIGNATURE_CRC integer, ESPACE_VERSION_ID integer, primary key(ID));
CREATE TABLE OSSYS_PERSISTENT_LOGIN(ID integer not null auto_increment, USER_ID integer not null, TENANT_ID integer not null,TERMINAL_TYPE nvarchar(16), SECRET nvarchar(50), EXPIRES datetime, primary key(ID));
CREATE TABLE OSSYS_DEVELOPER_ESPACE(ID integer not null auto_increment, DEVELOPER_ID integer, ESPACE_ID integer, SECURITY_LEVEL integer, primary key(ID));
CREATE TABLE OSSYS_RECOMPILATION_LOG(ID integer not null auto_increment, DATESTARTED datetime, DATEFINISHED datetime, `BY` integer,VERSION nvarchar(50),  primary key(ID));
CREATE TABLE OSSYS_PHYSICAL_NUMBER(ID integer not null auto_increment, PHONE_NUMBER nvarchar(50), IS_ACTIVE tinyint(1), primary key(ID));
CREATE TABLE OSSYS_SMS_ENTRY(ID integer not null auto_increment, SS_KEY nvarchar(25) not null, ESPACE_ID integer not null,REGEXP_PATTERN nvarchar(2000), IS_ACTIVE tinyint(1) not null, NAME nvarchar(50) not null, PATTERN nvarchar(2000), primary key(ID));
CREATE TABLE OSSYS_MSISDN_TENANT(ID integer not null auto_increment, MSISDN nvarchar(20) not null, VIRTUAL_NUMBER_ID integer not null, TENANT_ID integer not null, primary key(ID));
CREATE TABLE OSSYS_ENTITY_ATTR(ID integer not null auto_increment, ENTITY_ID integer not null, NAME nvarchar(50) not null,DESCRIPTION nvarchar(2000), SS_KEY nvarchar(50) not null, `TYPE` nvarchar(50) not null, LENGTH integer, DECIMALS integer,IS_MANDATORY tinyint(1) not null, IS_AUTONUMBER tinyint(1), DELETE_RULE nvarchar(20) not null, DEFAULT_LABEL nvarchar(50) not null,DEFAULT_VALUE nvarchar(2000), IS_ACTIVE tinyint(1), ORDER_NUM integer not null, primary key(ID));
CREATE TABLE OSSYS_REPORT_SLOWTIMER(ESPACE integer, TIMER_KEY nvarchar(50), AVGTIME decimal(37,8), COUNT integer ,TOTALTIME decimal(37,8), REPORTID integer, ERRORS integer);
CREATE TABLE OSSYS_CUSTOM_ATTRIBUTE(TENANT_ID integer not null, ID integer not null auto_increment, ENTITY_ID integer, LABEL nvarchar(50), DATA_TYPE nvarchar(50), ORDER_NBR integer, IS_ACTIVE tinyint(1), primary key(ID));
CREATE TABLE OSSYS_ESPACE(ID integer not null auto_increment, NAME nvarchar(35) not null, IS_MULTITENANT tinyint(1) not null,IS_ACTIVE tinyint(1), SS_KEY nvarchar(50) not null, IS_SYSTEM tinyint(1), VERSION_ID integer, IS_CONSISTENT tinyint(1) DEFAULT 0, ZONE_ID integer null, IS_USER_PROVIDER tinyint(1), USER_PROVIDER_NAME nvarchar(35), USER_PROVIDER_KEY nvarchar(50), primary key(ID));
CREATE TABLE OSSYS_DEVELOPER(ID integer not null auto_increment, USER_ID integer, ALLOW_NEW_ESPACE tinyint(1), ALLOW_EXTENSIONS tinyint(1), ALLOW_EXTERNAL_ENTITIES tinyint(1), primary key(ID));
CREATE TABLE OSSYS_ESPACE_CONFIGURATION(ID integer not null auto_increment, ESPACE_ID integer not null, NAME nvarchar(50) not null,VAL nvarchar(250), primary key(ID));
CREATE TABLE OSSYS_PARAMETER(ID integer not null auto_increment, NAME nvarchar(100) not null, VAL nvarchar(250), HOST nvarchar(50), primary key(ID));
CREATE TABLE OSSYS_WEB_REFERENCE(ID integer not null auto_increment, ESPACE_ID integer not null, IS_ACTIVE tinyint(1) not null, NAME nvarchar(100) not null, ORIGINAL_NAME nvarchar(100) not null, URL nvarchar(1000) not null, EFFECTIVE_URL nvarchar(1000), SS_KEY nvarchar(50) not null, LOG_REQUESTS tinyint(1), INTEGRATED_AUTHENTICATION tinyint(1), CERTIFICATE_ID integer, primary key(ID));
CREATE TABLE OSSYS_USER(ID integer not null auto_increment, TENANT_ID integer not null, IS_ACTIVE tinyint(1) not null, CREATION_DATE datetime not null, LAST_LOGIN datetime, NAME nvarchar(50), MobilePhone nvarchar(20), EMAIL nvarchar(50), USERNAME nvarchar(50), PASSWORD nvarchar(32), EXTERNAL_ID nvarchar(16), primary key(ID));
CREATE TABLE OSSYS_META_CYCLIC_JOB(ID integer not null auto_increment, ESPACE_ID integer not null, NAME nvarchar(50) not null,DEFAULT_SCHEDULE nvarchar(1000) not null, PRIORITY integer not null, IS_ACTIVE tinyint(1) not null, SS_KEY nvarchar(50) not null,TIMEOUT integer not null, EFFECTIVE_TIMEOUT integer not null, primary key(ID));
CREATE TABLE OSSYS_REPORT_SLOWSQL(ESPACE integer, QUERY nvarchar(500), AVGTIME decimal(37,8), TOTALTIME decimal(37,8), COUNT integer, REPORTID integer);
CREATE TABLE OSSYS_REPORT_SLOWSCREE(ESPACE integer, HITS integer, SCREEN_TYPE nvarchar(50), AVG_TIME decimal(37,8), TOTAL_TIME decimal(37,8), SCREEN nvarchar(50), REPORTID integer);
CREATE TABLE OSSYS_REPORT_LINE(ID integer not null auto_increment, REPORTTYPE nvarchar(20), CREATED datetime, STARTDATE datetime,ENDDATE datetime, DAILYUSAGE integer, primary key(ID));
CREATE TABLE OSSYS_REPORT_HOURLYUSA(ESPACEID integer, REPORTID integer, WEBHITS integer, WAPHITS integer, INBOUNDSMS integer,OUTBOUNDSMS integer, WEBSERVICES integer, ERRORS integer, `HOUR` nvarchar(50), SLOWWEBSCREENS integer, SLOWWAPSCREENS integer,TIMERRUNS integer, SLOWTIMERRUNS integer);
CREATE TABLE OSSYS_USER_ROLE(ID integer not null auto_increment, USER_ID integer not null, ROLE_ID integer not null, TENANT_ID integer not null, primary key(ID));
CREATE TABLE OSSYS_REPORT_SLOWWEBSE(ESPACE integer, NAME nvarchar(1000), METHOD nvarchar(50), AVGTIME decimal(37,8), COUNT integer,TOTALTIME decimal(37,8), REPORTID integer, ERRORS integer);
CREATE TABLE OSSYS_CERTIFICATE(ID integer not null auto_increment, NAME nvarchar(100), PATH nvarchar(256), primary key(ID));
CREATE TABLE OSSYS_ESPACE_REFERENCE(ID integer not null auto_increment, CONSUMER_VERSION_ID integer not null, NAME nvarchar(50) not null, KIND nvarchar(20) not null, SS_KEY nvarchar(50) not null, SIGNATURE mediumtext not null, PRODUCER_NAME nvarchar(50) not null,PRODUCER_KIND nvarchar(20) not null, PRODUCER_SS_KEY nvarchar(50) not null, PUBLISHED_PROD_VERSION_ID integer,PUBLISHED_PROD_VERSION_NUM integer not null, IS_BROKEN tinyint(1) not null, MISSING_STATUS tinyint(1) null, primary key(ID));
CREATE TABLE OSSYS_REPORT_TOPERRORS(MESSAGE nvarchar(2000), COUNT integer, ESPACE integer, REPORTID integer);
CREATE TABLE OSSYS_REPORT_TYPE(REPORT_TYPE nvarchar(20) not null, primary key(REPORT_TYPE));
CREATE TABLE OSSYS_REPORT_SU(ID integer not null auto_increment, OMLCOMPLEXITY integer, ESPACEID integer, primary key(ID));
CREATE TABLE OSSYS_WEB_SERVICE(ID integer not null auto_increment, ESPACE_ID integer not null, IS_ACTIVE tinyint(1) not null, NAME nvarchar(100) not null, SS_KEY nvarchar(50) not null, INTERNAL_ACCESS tinyint(1) ,SECURE_CONNECTION tinyint(1),INTEGRATED_AUTHENTICATION tinyint(1), primary key(ID));
CREATE TABLE OSSYS_SITE_PROPERTY(ID integer not null auto_increment, TENANT_ID integer not null, SITE_PROPERTY_DEFINITION_ID integer not null, PROPERTY_VALUE nvarchar(2000) not null, primary key(ID));
CREATE TABLE OSSYS_ROLE(ID integer not null auto_increment, ESPACE_ID integer not null, SS_KEY nvarchar(50) not null, NAME nvarchar(50) not null, DESCRIPTION nvarchar(2000), PERSISTENT tinyint(1) not null, IS_ACTIVE tinyint(1), primary key(ID));
CREATE TABLE OSSYS_REPORT_ESPACEUSA(ESPACEID integer, REPORTID integer, WEBHITS integer, WAPHITS integer, INBOUNDSMS integer,OUTBOUNDSMS integer, WEBSERVICES integer, ERRORS integer, USERLOGINS integer, INBOUNDMSISDN integer, WAPMSISDN integer, ACTIVEUSERS integer, SESSIONS integer, SESSIONDURATION integer, HITSPERSESSION integer, SLOWWEBHITS integer, SLOWWAPHITS integer, TIMERRUNS integer, SLOWTIMERRUNS integer);
CREATE TABLE OSSYS_VIRTUAL_NUMBER(ID integer not null auto_increment, PHYSICAL_NUMBER_ID integer not null, USES_TENANT_MSISDN tinyint(1) not null,TENANT_ID integer not null, SMSENTRY_ID integer not null, IS_ACTIVE tinyint(1), ORDER_PRIORITY integer not null, primary key(ID));
CREATE TABLE OSSYS_SITE_PROPERTY_DEFINITION(ID integer not null auto_increment, ESPACE_ID integer not null, SS_KEY nvarchar(50) not null, NAME nvarchar(50) not null, DESCRIPTION nvarchar(2000), IS_ACTIVE tinyint(1) not null, DEFAULT_VALUE nvarchar(2000) not null,DATA_TYPE nvarchar(50) not null, primary key(ID));
CREATE TABLE OSSYS_SERVER(ID integer not null auto_increment, NAME nvarchar(50) not null, IP_ADDRESS nvarchar(50) not null, IS_ACTIVE tinyint(1) not null, primary key(ID));
CREATE TABLE OSSYS_ESPACE_EXTENSION(ID integer not null auto_increment, ESPACE_ID integer not null, EXTENSION_ID integer not null, primary key(ID));
CREATE TABLE OSSYS_TENANT(ID integer not null auto_increment, NAME nvarchar(20) not null, ESPACE_ID integer not null, IS_ACTIVE tinyint(1) not null, primary key(ID));
CREATE TABLE OSSYS_ESPACE_VERSION(ID integer not null auto_increment,VERSION integer, OML_FILE longblob, UPLOADED_BY integer,UPLOADED_DATE datetime, ESPACE_ID integer, IS_VALID tinyint(1), SERVICE_STUDIO_VERSION nvarchar(50), BASED_ON_PREVIOUS tinyint(1), DESCRIPTION nvarchar(2000), HASH nvarchar(1000), LAST_MODIFIED datetime default '1900-01-01 00:00:00', IS_USER_PROVIDER tinyint(1), USER_PROVIDER_NAME nvarchar(35), USER_PROVIDER_KEY nvarchar(50), PUBLISHING_ID integer null, primary key(ID));
CREATE TABLE OSSYS_PUBLISHING(ID integer not null auto_increment, VERSION_ID integer, PUBLISHED_BY integer, PUBLISHED_DATE datetime, HUBSERVERVERSION nvarchar(50), DEBUG_MODE tinyint(1), primary key(ID));
CREATE TABLE OSSYS_CYCLIC_JOB(ID integer not null auto_increment, META_CYCLIC_JOB_ID integer not null, TENANT_ID integer not null,SCHEDULE nvarchar(1000), LAST_RUN datetime, NEXT_RUN datetime, LAST_DURATION integer, IS_RUNNING_SINCE datetime, IS_RUNNING_BY nvarchar(50), primary key(ID));
CREATE TABLE OSSYS_EXTENSION(ID integer not null auto_increment, NAME nvarchar(50) not null, SS_KEY nvarchar(50) not null, IS_SYSTEM tinyint(1) not null, VERSION_ID integer null, IS_ACTIVE tinyint(1) null default 0, PUBLISHED_DATE datetime, PUBLISHED_BY integer, primary key(id));
CREATE TABLE OSSYS_EXTENSION_VERSION(ID integer not null auto_increment, GENERATION integer, XIF_FILE longblob, UPLOADED_BY integer, UPLOADED_DATE datetime, EXTENSION_ID integer, IS_VALID tinyint(1), XIF_VERSION nvarchar(50), TOOL_VERSION nvarchar(50), DESCRIPTION nvarchar(2000), HASH nvarchar(1000), LAST_MODIFIED datetime DEFAULT '1900-01-01 00:00:00', primary key(ID));
CREATE TABLE OSSYS_EXTENSION_VERSION_SIG(ID integer not null auto_increment, SIGNATURE mediumtext, SIGNATURE_CRC integer, EXTENSION_VERSION_ID integer, primary key(ID));
CREATE TABLE OSSYS_EXTENSION_DEPENDENCY(ID integer NOT NULL auto_increment, EXTENSION_ID integer not null, FILENAME nvarchar(256) not null, FILE_CONTENT longblob null, LAST_MODIFIED datetime null, SS_KEY nvarchar(50) null, DESCRIPTION nvarchar(2000) null, COMPILE_ACTION nvarchar(50) null, PATH nvarchar(2000) null, primary key(ID));

insert into OSSYS_PARAMETER(name,val) values ('submitseviceurl', 'http://hubedition.outsystems.net/issues/outsystems/submit.asmx');
insert into OSSYS_PARAMETER(name,val) values ('invalidMessageForPhone', 'Sorry, but the phone %to does not accept the message %message');
insert into OSSYS_PARAMETER(name,val) values ('smshandlerErrorMessage', 'Sorry, but your message could not be processed. The error has been logged. Please try again.');
INSERT INTO OSSYS_PARAMETER (name,val) VALUES ('dateFormat', 'yyyy-MM-dd'); 

CREATE TABLE OSSYS_ESPACE_HASHSET(ID integer not null auto_increment, ESPACE_VERSION_ID integer, HASHSET longtext, primary key(ID));

CREATE INDEX OSIDX_OSSYS_ESPACE_REF58771 ON OSSYS_ESPACE_REFERENCE (CONSUMER_VERSION_ID, PRODUCER_SS_KEY);
CREATE INDEX OSIDX_OSSYS_ESPACE_REF51593 ON OSSYS_ESPACE_REFERENCE (PRODUCER_SS_KEY);

CREATE TABLE OSSYS_ACTIVATION(ID integer not null auto_increment, INFO nvarchar(100) null, HOST nvarchar(100) null, BINARY_DATA longblob null, `TEXT` nvarchar(1000) null, primary key(ID));
INSERT INTO OSSYS_ACTIVATION(INFO) VALUES('Server Mode');

CREATE TABLE OSSYS_ZONE(ID integer not null auto_increment, NAME nvarchar(50) not null, primary key(ID));
CREATE TABLE OSSYS_ZONE_SERVER(ID integer not null auto_increment, ZONE_ID integer not null, SERVER_ID integer not null, primary key(ID));
ALTER TABLE OSSYS_ZONE_SERVER ADD ( CONSTRAINT OSFRK_OSSYS_ZONE_SERVER_O FOREIGN KEY ( SERVER_ID ) REFERENCES OSSYS_SERVER ( ID ) ON DELETE CASCADE );
ALTER TABLE OSSYS_ZONE_SERVER ADD ( CONSTRAINT OSFRK_OSSYS_ZONE_SERVER_O2 FOREIGN KEY ( ZONE_ID ) REFERENCES OSSYS_ZONE ( ID ) ON DELETE CASCADE );

CREATE TABLE OSSYS_SHAREDCONFIGURATION (ID integer not null auto_increment, NAME nvarchar(50) NULL, KIND nvarchar(50) NULL, DESCRIPTION nvarchar(255) NULL, VALUE longtext NULL, primary key(ID));
CREATE TABLE OSSYS_ESPACE_SHAREDCONFIG (ID integer not null auto_increment, ESPACEID  integer DEFAULT NULL NULL, SHAREDCONFIGURATIONID integer DEFAULT NULL NULL, primary key(ID));
ALTER TABLE OSSYS_ESPACE_SHAREDCONFIG ADD CONSTRAINT OSFRK_OSSYS_ESPACE_SHAREDCONF0 FOREIGN KEY (ESPACEID) REFERENCES OSSYS_ESPACE (ID) ON DELETE CASCADE;
ALTER TABLE OSSYS_ESPACE_SHAREDCONFIG ADD CONSTRAINT OSFRK_OSSYS_ESPACE_SHAREDCONF1 FOREIGN KEY (SHAREDCONFIGURATIONID) REFERENCES OSSYS_SHAREDCONFIGURATION (ID) ON DELETE CASCADE;

ALTER TABLE OSSYS_ESPACE_VERSION ADD LAST_UPGRADE_VERSION nvarchar(50);

CREATE TABLE OSLOG_CYCLIC_JOB_0(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_1(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_2(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_3(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_4(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_5(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_6(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_7(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_8(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);
CREATE TABLE OSLOG_CYCLIC_JOB_9(INSTANT datetime NOT NULL, DURATION integer, CYCLIC_JOB_KEY nvarchar(20) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), SHOULD_HAVE_RUN_AT datetime NOT NULL,NEXT_RUN datetime NOT NULL, CYCLE integer NOT NULL);

CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_0 ON OSLOG_CYCLIC_JOB_0 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_1 ON OSLOG_CYCLIC_JOB_1 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_2 ON OSLOG_CYCLIC_JOB_2 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_3 ON OSLOG_CYCLIC_JOB_3 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_4 ON OSLOG_CYCLIC_JOB_4 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_5 ON OSLOG_CYCLIC_JOB_5 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_6 ON OSLOG_CYCLIC_JOB_6 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_7 ON OSLOG_CYCLIC_JOB_7 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_8 ON OSLOG_CYCLIC_JOB_8 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_CYCLIC_JOB_ESPACE_9 ON OSLOG_CYCLIC_JOB_9 ( Instant,Espace_Id );

CREATE VIEW OSLOG_CYCLIC_JOB AS SELECT * FROM OSLOG_CYCLIC_JOB_0;


CREATE TABLE OSLOG_ERROR_0(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_1(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_2(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_3(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_4(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_5(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_6(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_7(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_8(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));
CREATE TABLE OSLOG_ERROR_9(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(2000) NOT NULL, STACK nvarchar(2000) NOT NULL,MODULE_NAME nvarchar(15) NOT NULL, SERVER nvarchar(50) NOT NULL, CYCLE integer NOT NULL, primary key(ID));

CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_0 ON OSLOG_ERROR_0( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_1 ON OSLOG_ERROR_1( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_2 ON OSLOG_ERROR_2( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_3 ON OSLOG_ERROR_3( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_4 ON OSLOG_ERROR_4( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_5 ON OSLOG_ERROR_5( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_6 ON OSLOG_ERROR_6( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_7 ON OSLOG_ERROR_7( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_8 ON OSLOG_ERROR_8( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_ERROR_ESPACE_ID_9 ON OSLOG_ERROR_9( Instant,Espace_Id );


CREATE VIEW OSLOG_ERROR AS SELECT * FROM OSLOG_ERROR_0;


CREATE TABLE OSLOG_GENERAL_0(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_1(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_2(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_3(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_4(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_5(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_6(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_7(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_8(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_GENERAL_9(INSTANT datetime NOT NULL,SESSION_ID nvarchar(24) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, ERROR_ID nvarchar(50), MESSAGE nvarchar(200), MESSAGE_TYPE nvarchar(10), MODULE_NAME nvarchar(15), CYCLE integer NOT NULL);


CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_0 ON OSLOG_GENERAL_0 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_1 ON OSLOG_GENERAL_1 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_2 ON OSLOG_GENERAL_2 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_3 ON OSLOG_GENERAL_3 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_4 ON OSLOG_GENERAL_4 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_5 ON OSLOG_GENERAL_5 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_6 ON OSLOG_GENERAL_6 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_7 ON OSLOG_GENERAL_7 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_8 ON OSLOG_GENERAL_8 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_GENERAL_ESPACE_ID_9 ON OSLOG_GENERAL_9 ( Instant,Espace_Id );

CREATE VIEW OSLOG_GENERAL AS SELECT * FROM OSLOG_GENERAL_0;


CREATE TABLE OSLOG_SCREEN_0(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_1(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_2(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_3(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_4(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_5(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_6(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_7(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_8(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));
CREATE TABLE OSLOG_SCREEN_9(INSTANT datetime NOT NULL, DURATION integer, SCREEN nvarchar(50), SESSION_ID nvarchar(24) NOT NULL,USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MSISDN nvarchar(20), SCREEN_TYPE nvarchar(10) NOT NULL, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50));


CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_0 ON OSLOG_SCREEN_0 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_1 ON OSLOG_SCREEN_1 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_2 ON OSLOG_SCREEN_2 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_3 ON OSLOG_SCREEN_3 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_4 ON OSLOG_SCREEN_4 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_5 ON OSLOG_SCREEN_5 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_6 ON OSLOG_SCREEN_6 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_7 ON OSLOG_SCREEN_7 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_8 ON OSLOG_SCREEN_8 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SCREEN_ESPACE_ID_9 ON OSLOG_SCREEN_9 ( Instant,Espace_Id );

CREATE VIEW OSLOG_SCREEN AS SELECT * FROM OSLOG_SCREEN_0;


CREATE TABLE OSLOG_SMS_0(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_1(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_2(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_3(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_4(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_5(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_6(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_7(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_8(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));
CREATE TABLE OSLOG_SMS_9(INSTANT datetime NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, MESSAGE nvarchar(480) NOT NULL, MESSAGE_ID nvarchar(50) NOT NULL, `TYPE` nvarchar(2) , CUSTOM_ID integer NOT NULL, CYCLE integer NOT NULL, ORIGINAL_MESSAGE_ID nvarchar(50), MSISDN nvarchar(50), LARGE_ACCOUNT nvarchar(50), BILLING_DESCRIPTION nvarchar(80),BILLING_CODE nvarchar(50), CONNECTION nvarchar(50), OPERATOR_CODE nvarchar(20), CUSTOM_1 nvarchar(50), CUSTOM_2 nvarchar(50), CUSTOM_3 nvarchar(50), TENANT_PATH nvarchar(56), SCREEN_NAME nvarchar(50), DLR_STATUS integer, ERROR_ID nvarchar(56));


CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_0 ON OSLOG_SMS_0 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_1 ON OSLOG_SMS_1 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_2 ON OSLOG_SMS_2 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_3 ON OSLOG_SMS_3 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_4 ON OSLOG_SMS_4 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_5 ON OSLOG_SMS_5 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_6 ON OSLOG_SMS_6 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_7 ON OSLOG_SMS_7 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_8 ON OSLOG_SMS_8 ( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_SMS_ESPACE_ID_9 ON OSLOG_SMS_9 ( Instant,Espace_Id );

CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_0 ON OSLOG_SMS_0 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_1 ON OSLOG_SMS_1 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_2 ON OSLOG_SMS_2 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_3 ON OSLOG_SMS_3 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_4 ON OSLOG_SMS_4 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_5 ON OSLOG_SMS_5 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_6 ON OSLOG_SMS_6 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_7 ON OSLOG_SMS_7 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_8 ON OSLOG_SMS_8 ( MSISDN,Message_Id );
CREATE INDEX IDX_OSLOG_SMS_MSIDN_MESSAGEI_9 ON OSLOG_SMS_9 ( MSISDN,Message_Id );


CREATE VIEW OSLOG_SMS AS SELECT * FROM OSLOG_SMS_0;


CREATE TABLE OSLOG_WEB_REFERENCE_0(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_1(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_2(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_3(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_4(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_5(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_6(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_7(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_8(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_REFERENCE_9(INSTANT datetime NOT NULL, DURATION integer, URL nvarchar(1000) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);


CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_0 ON OSLOG_WEB_REFERENCE_0( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_1 ON OSLOG_WEB_REFERENCE_1( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_2 ON OSLOG_WEB_REFERENCE_2( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_3 ON OSLOG_WEB_REFERENCE_3( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_4 ON OSLOG_WEB_REFERENCE_4( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_5 ON OSLOG_WEB_REFERENCE_5( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_6 ON OSLOG_WEB_REFERENCE_6( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_7 ON OSLOG_WEB_REFERENCE_7( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_8 ON OSLOG_WEB_REFERENCE_8( Instant,Espace_Id );
CREATE INDEX IDX_OSLOG_WEB_REFERENCE_ESP_9 ON OSLOG_WEB_REFERENCE_9( Instant,Espace_Id );

CREATE VIEW OSLOG_WEB_REFERENCE AS SELECT * FROM OSLOG_WEB_REFERENCE_0;


CREATE TABLE OSLOG_WEB_SERVICE_0(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_1(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_2(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_3(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_4(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_5(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_6(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_7(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_8(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);
CREATE TABLE OSLOG_WEB_SERVICE_9(INSTANT datetime NOT NULL, DURATION integer, NAME nvarchar(100) NOT NULL, METHOD nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, CLIENT_IP nvarchar(15) NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50), CYCLE integer NOT NULL);


CREATE VIEW OSLOG_WEB_SERVICE AS SELECT * FROM OSLOG_WEB_SERVICE_0;

ALTER TABLE OSLOG_SCREEN_0 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_1 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_2 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_3 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_4 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_5 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_6 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_7 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_8 ADD Viewstate_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_9 ADD Viewstate_Bytes integer(8);

ALTER TABLE OSLOG_SCREEN_0 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_1 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_2 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_3 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_4 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_5 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_6 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_7 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_8 ADD Session_Bytes integer(8);
ALTER TABLE OSLOG_SCREEN_9 ADD Session_Bytes integer(8);

ALTER TABLE OSLOG_SCREEN_0 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_1 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_2 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_3 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_4 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_5 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_6 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_7 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_8 ADD Session_Requests integer(4);
ALTER TABLE OSLOG_SCREEN_9 ADD Session_Requests integer(4);

ALTER TABLE OSLOG_ERROR_0 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_1 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_2 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_3 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_4 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_5 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_6 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_7 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_8 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_ERROR_9 MODIFY SESSION_ID nvarchar(50);

ALTER TABLE OSLOG_GENERAL_0 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_1 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_2 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_3 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_4 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_5 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_6 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_7 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_8 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_GENERAL_9 MODIFY SESSION_ID nvarchar(50);

ALTER TABLE OSLOG_SCREEN_0 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_1 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_2 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_3 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_4 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_5 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_6 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_7 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_8 MODIFY SESSION_ID nvarchar(50);
ALTER TABLE OSLOG_SCREEN_9 MODIFY SESSION_ID nvarchar(50);

ALTER TABLE OSLOG_GENERAL_0 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_1 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_2 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_3 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_4 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_5 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_6 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_7 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_8 MODIFY MESSAGE nvarchar(2000);
ALTER TABLE OSLOG_GENERAL_9 MODIFY MESSAGE nvarchar(2000);


CREATE TABLE OSSYS_ENTITY_RECORD (ID integer NOT NULL auto_increment, DATA_ID nvarchar(2000) NOT NULL, NAME nvarchar(50) NOT NULL, SS_KEY nvarchar(100) NOT NULL, ENTITY_SS_KEY nvarchar(100) NOT NULL, ESPACE_ID integer NOT NULL, IS_ACTIVE tinyint(1) NOT NULL, primary key(ID)) ;

ALTER TABLE OSSYS_EXTENSION_VERSION ADD Has_SAP tinyint(1);
ALTER TABLE OSSYS_ESPACE_VERSION ADD Has_HTTPS tinyint(1);
ALTER TABLE OSSYS_ESPACE_VERSION ADD Has_IntegratedAuthentication tinyint(1);
ALTER TABLE OSSYS_ESPACE_VERSION ADD Has_MobileWeb tinyint(1);
ALTER TABLE OSSYS_ESPACE_VERSION ADD Has_SMS tinyint(1);

ALTER TABLE OSSYS_ENTITY ADD Is_Active_Attribute nvarchar(50) NULL;
ALTER TABLE OSSYS_ENTITY ADD Label_Attribute nvarchar(50) NULL;
ALTER TABLE OSSYS_ENTITY ADD Order_By_Attribute nvarchar(50) NULL;
ALTER TABLE OSSYS_ENTITY ADD Data_Kind nvarchar(20) NULL;
ALTER TABLE OSSYS_ENTITY ADD Multilingual tinyint(1) DEFAULT 0 NOT NULL;

CREATE TABLE OSLOG_EXTENSION_0(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_1(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_2(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_3(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_4(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_5(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_6(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_7(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_8(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));
CREATE TABLE OSLOG_EXTENSION_9(INSTANT datetime NOT NULL,DURATION integer, ACTION_NAME nvarchar(50), SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer NOT NULL, EXTENSION_ID integer, CYCLE integer NOT NULL, EXECUTED_BY nvarchar(50), ERROR_ID nvarchar(50));


CREATE INDEX IDX_OSLOG_EXTENSION_ID_0 ON OSLOG_EXTENSION_0 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_1 ON OSLOG_EXTENSION_1 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_2 ON OSLOG_EXTENSION_2 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_3 ON OSLOG_EXTENSION_3 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_4 ON OSLOG_EXTENSION_4 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_5 ON OSLOG_EXTENSION_5 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_6 ON OSLOG_EXTENSION_6 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_7 ON OSLOG_EXTENSION_7 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_8 ON OSLOG_EXTENSION_8 (INSTANT, EXTENSION_ID, ESPACE_ID);
CREATE INDEX IDX_OSLOG_EXTENSION_ID_9 ON OSLOG_EXTENSION_9 (INSTANT, EXTENSION_ID, ESPACE_ID);

CREATE VIEW OSLOG_EXTENSION AS SELECT * FROM OSLOG_EXTENSION_0;


ALTER TABLE OSLOG_SCREEN_0 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_1 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_2 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_3 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_4 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_5 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_6 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_7 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_8 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;
ALTER TABLE OSLOG_SCREEN_9 ADD ACCESS_MODE nvarchar(10) DEFAULT 'Screen' NOT NULL;


ALTER TABLE OSSYS_ESPACE_VERSION ADD (HAS_WEBSERVICES tinyint(1) DEFAULT 0 NOT NULL);
ALTER TABLE OSSYS_REPORT_SU ADD (LICENSED_SUS integer DEFAULT 0 NOT NULL);

ALTER TABLE OSSYS_REPORT_SU ADD (USED_LICENSED_SUS integer DEFAULT 0 NOT NULL);


ALTER TABLE OSLOG_CYCLIC_JOB_0 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_1 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_2 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_3 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_4 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_5 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_6 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_7 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_8 MODIFY CYCLIC_JOB_KEY nvarchar(50);
ALTER TABLE OSLOG_CYCLIC_JOB_9 MODIFY CYCLIC_JOB_KEY nvarchar(50);

ALTER TABLE OSSYS_SMS_ENTRY MODIFY SS_KEY nvarchar(50);
CREATE UNIQUE INDEX OSIDX_OSSYS_SMS_ENTRY_6SS_KEY_ ON OSSYS_SMS_ENTRY ( SS_KEY,ESPACE_ID );

ALTER TABLE OSSYS_ENTITY_ATTR MODIFY TYPE nvarchar(200);
ALTER TABLE OSSYS_ESPACE_REFERENCE DROP COLUMN SIGNATURE;

ALTER TABLE OSSYS_EXTENSION_VERSION_SIG ADD (Signature_Binary longblob);
ALTER TABLE OSSYS_EXTENSION_VERSION_SIG ADD Signature_Hash nvarchar(50);
ALTER TABLE OSSYS_EXTENSION_VERSION_SIG DROP COLUMN Signature;
ALTER TABLE OSSYS_EXTENSION_VERSION_SIG DROP COLUMN Signature_CRC;

ALTER TABLE OSSYS_ESPACE ADD Is_Locked tinyint(1) DEFAULT 0 NOT NULL;

CREATE TABLE OSSYS_BPM_EVENT_QUEUE (ID integer NOT NULL auto_increment, ESPACE_ID integer, TENANT_ID integer, PROCESS_DEF_ID integer, DATA_ID nvarchar(500), ENQUEUE_TIME datetime, DEQUEUE_TIME datetime, ERROR_COUNT integer, NEXT_RUN datetime, primary key(ID));
CREATE TABLE OSSYS_BPM_PROCESS_DEFINITION (ID integer NOT NULL auto_increment, NAME nvarchar(100) not null default '', LABEL nvarchar(100) not null default '', DESCRIPTION nvarchar(2000) not null default '', SS_KEY nvarchar(100) NOT NULL, IS_ACTIVE tinyint(1) DEFAULT 0, ESPACE_ID integer, IS_LOCKED tinyint(1) DEFAULT 0, PROCESS_ENTITY_ID integer, LOCKED_BY integer default null, LOCKED_DATE datetime default '1900-01-01 00:00:00', primary key(ID));
CREATE TABLE OSSYS_BPM_ACTIVITY_DEFINITION (ID integer NOT NULL auto_increment, SS_KEY nvarchar(100) NOT NULL, NAME nvarchar(100), LABEL nvarchar(100), DESCRIPTION nvarchar(2000), KIND integer NULL, PROCESS_DEF_ID integer, IS_ACTIVE tinyint(1) DEFAULT 0, DISPLAY_X integer DEFAULT 0, DISPLAY_Y integer DEFAULT 0, INVOKED_PROCESS_DEF_ID integer, REQUIRES_PERMISSION tinyint(1) DEFAULT 0, primary key(ID));
CREATE TABLE OSSYS_BPM_PROCESS (TENANT_ID integer NOT NULL DEFAULT 0, ID integer NOT NULL auto_increment, LABEL nvarchar(200) not null default '', CREATED datetime DEFAULT '1900-01-01 00:00:00', CREATED_BY integer, PROCESS_DEF_ID integer, PARENT_PROCESS_ID integer, PARENT_ACTIVITY_ID integer, TOP_PROCESS_ID integer, STATUS_ID integer, LAST_MODIFIED datetime DEFAULT '1900-01-01 00:00:00',LAST_MODIFIED_BY integer NULL, primary key(ID));
CREATE TABLE OSSYS_BPM_ACTIVITY (TENANT_ID integer NOT NULL DEFAULT 0, ID integer NOT NULL, ACTIVITY_DEF_ID integer, PROCESS_ID integer, NAME nvarchar(100), USER_ID integer, CREATED datetime DEFAULT '1900-01-01 00:00', OPENED datetime DEFAULT '1900-01-01 00:00', CLOSED datetime DEFAULT '1900-01-01 00:00', STATUS_ID integer NULL, IS_RUNNING_SINCE datetime DEFAULT '1900-01-01 00:00', IS_RUNNING_AT nvarchar(50), NEXT_RUN datetime DEFAULT '1900-01-01 00:00', PRECEDENT_ACTIVITY_ID integer, PRECEDENT_OUTCOME nvarchar(50), DUE_DATE datetime DEFAULT '1900-01-01 00:00', EXPIRED tinyint(1) DEFAULT 0, SKIPPED tinyint(1) DEFAULT 0, ERROR_COUNT integer DEFAULT 0, INBOX_DETAIL nvarchar(100));
CREATE TABLE OSSYS_BPM_ACTIVITY_KIND (ID int NOT NULL, NAME nvarchar(50));
CREATE TABLE OSSYS_BPM_ACTIVITY_STATUS (ID integer NOT NULL, NAME nvarchar(50), IS_TERMINAL tinyint(1) DEFAULT 0, APPEARS_IN_INBOX tinyint(1) DEFAULT 0);
CREATE TABLE OSSYS_BPM_PROCESS_STATUS (ID integer NOT NULL, NAME nvarchar(50), IS_TERMINAL tinyint(1) DEFAULT 0);
CREATE TABLE OSSYS_BPM_PROCESS_UPGRADE (ID integer NOT NULL auto_increment, PROCESS_ID integer, ACTIVITY_DEF_ID integer, ACTIVE tinyint(1) DEFAULT 0, PAST tinyint(1) DEFAULT 0, FUTURE tinyint(1) DEFAULT 0, DELETED tinyint(1) DEFAULT 0, ESPACE_VERSION_ID integer, primary key(ID));
CREATE TABLE OSSYS_BPM_PROCESS_DEPENDENCY (ID integer NOT NULL auto_increment, PROCESS_DEF_SS_KEY nvarchar(100), ESPACE_VERSION_ID integer, DEPENDENCYLIST longblob, primary key(ID));
CREATE TABLE OSSYS_BPM_ACTIVITY_DEF_ROLE (ID integer NOT NULL auto_increment, ROLE_ID integer, ACTIVITY_DEF_ID integer, primary key(ID));
CREATE TABLE OSSYS_BPM_ACTIVITY_DEF_LINK (ID integer NOT NULL auto_increment, SS_KEY nvarchar(100), SOURCE_ACTIVITY_DEF_ID integer, TARGET_ACTIVITY_DEF_ID integer, IS_ACTIVE tinyint(1) DEFAULT 0, OUTCOME nvarchar(10), primary key(ID));

ALTER TABLE OSSYS_ESPACE_VERSION_SIGNATURE DROP COLUMN SIGNATURE;
ALTER TABLE OSSYS_ESPACE_VERSION_SIGNATURE DROP COLUMN SIGNATURE_CRC;
CREATE TABLE OSSYS_ESPACE_FRAGMENTS (ID integer NOT NULL auto_increment, ESPACE_ID integer, USER_ID integer, FRAGMENTS longtext, primary key(ID));

CREATE TABLE OSSYS_BPM_PROCESS_INPUT_DEF (ID integer NOT NULL auto_increment, SS_KEY nvarchar(100) NOT NULL, PROCESS_DEF_ID integer, NAME nvarchar(100), DESCRIPTION nvarchar(2000), IS_ACTIVE tinyint(1) DEFAULT 0, DATA_TYPE nvarchar(50), IS_MANDATORY tinyint(1) DEFAULT 0, DEFAULT_VALUE nvarchar(2000), SS_TYPE nvarchar(200), primary key(ID));
CREATE TABLE OSSYS_BPM_PROCESS_INPUT (TENANT_ID integer DEFAULT 0 NOT NULL, ID integer NOT NULL auto_increment, INPUT_DEF_ID integer, PROCESS_ID integer, SS_KEY nvarchar(100) NOT NULL, NAME nvarchar(100), DATA_TYPE nvarchar(200) NOT NULL, INPUT_VALUE nvarchar(2000), SS_TYPE nvarchar(200) NOT NULL, primary key(ID));
CREATE TABLE OSSYS_BPM_PROCESS_OUTPUT_DEF (ID integer NOT NULL, SS_KEY nvarchar(100) NOT NULL, PROCESS_DEF_ID integer, NAME nvarchar(100), DESCRIPTION nvarchar(2000), IS_ACTIVE tinyint(1) DEFAULT 0, DATA_TYPE nvarchar(50), DEFAULT_VALUE nvarchar(2000), SS_TYPE nvarchar(200), primary key(ID));
CREATE TABLE OSSYS_BPM_PROCESS_OUTPUT (TENANT_ID integer DEFAULT 0 NOT NULL, ID integer NOT NULL auto_increment, OUTPUT_DEF_ID integer, PROCESS_ID integer, SS_KEY nvarchar(100) NOT NULL, NAME nvarchar(100), DATA_TYPE nvarchar(200) NOT NULL, OUTPUT_VALUE nvarchar(2000), SS_TYPE nvarchar(200) NOT NULL, primary key(ID));
CREATE TABLE OSSYS_BPM_ACTIVITY_OUTPUT_DEF (ID integer NOT NULL, SS_KEY nvarchar(100) NOT NULL, ACTIVITY_DEF_ID integer, NAME nvarchar(100), DESCRIPTION nvarchar(2000), IS_ACTIVE tinyint(1) DEFAULT 0, DATA_TYPE nvarchar(50), IS_INPUT tinyint(1) DEFAULT 0, IS_MANDATORY tinyint(1) DEFAULT 0, DEFAULT_VALUE nvarchar(2000), SS_TYPE nvarchar(200), primary key(ID));
CREATE TABLE OSSYS_BPM_ACTIVITY_OUTPUT (TENANT_ID integer DEFAULT 0 NOT NULL, ID integer NOT NULL auto_increment, OUTPUT_DEF_ID integer, ACTIVITY_ID integer, SS_KEY nvarchar(100) NOT NULL, NAME nvarchar(100), DATA_TYPE nvarchar(200) NOT NULL, OUTPUT_VALUE nvarchar(2000), SS_TYPE nvarchar(200) NOT NULL, primary key(ID));

ALTER TABLE OSSYS_ESPACE ADD LOCKED_DATE datetime;

CREATE TABLE OSSYS_EMAIL (ID integer NOT NULL auto_increment, `FROM` nvarchar(200), `TO` nvarchar(2000), CC nvarchar(2000), BCC nvarchar(2000), SUBJECT nvarchar(2000), CREATED datetime, ACTIVITY_ID integer DEFAULT 0, EMAIL_DEFINITION_ID integer DEFAULT 0, STORE_CONTENT tinyint(1) DEFAULT 0, IS_TEST_EMAIL tinyint(1) DEFAULT 0, `SIZE` integer DEFAULT 0, MESSAGE_ID nvarchar(200), primary key(ID));
CREATE TABLE OSSYS_EMAIL_DEFINITION (ID integer NOT NULL auto_increment, ESPACE_ID integer, NAME nvarchar(50), SS_KEY nvarchar(100), DESCRIPTION nvarchar(2000), IS_ACTIVE tinyint(1) DEFAULT 0, primary key(ID));
CREATE TABLE OSSYS_EMAIL_STATUS (ID integer NOT NULL, LAST_ERROR_ID nvarchar(50), ERROR_COUNT tinyint(1) DEFAULT 0, NEXT_RUN datetime, IS_RUNNING_AT nvarchar(50), IS_RUNNING_SINCE datetime, SENT datetime, primary key(ID));
CREATE TABLE OSSYS_EMAIL_CONTENT (ID integer NOT NULL, CONTENT longblob, primary key(ID));

ALTER TABLE OSSYS_ENTITY ADD EXPOSE_PROCESS_EVENTS tinyint(1);
ALTER TABLE OSSYS_ENTITY ADD EVENT_TABLE_NAME nvarchar(2000);
ALTER TABLE OSSYS_ENTITY add MULTILINGUAL_TABLE_NAME nvarchar(2000);

CREATE TABLE OSSYS_LOG_LICENSEUSERUSAGE(ID integer NOT NULL auto_increment, USERTYPE nvarchar(5), `DATETIME` datetime, SESSIONS integer DEFAULT 0, SESSIONMEDIAN integer DEFAULT 0, SESSIONLIMIT integer DEFAULT 0, primary key(ID));

ALTER TABLE OSSYS_ENTITY MODIFY DESCRIPTION nvarchar(2000);
ALTER TABLE OSSYS_ENTITY_ATTR MODIFY DESCRIPTION nvarchar(2000);
ALTER TABLE OSSYS_ENTITY_ATTR MODIFY DEFAULT_VALUE nvarchar(2000);
ALTER TABLE OSSYS_SITE_PROPERTY_DEFINITION MODIFY DESCRIPTION nvarchar(2000);

GO

ALTER TABLE OSSYS_ENTITY ADD BASE_VIEW_NAME nvarchar(2000);

ALTER TABLE OSSYS_SERVER ADD HOST_SERIAL nvarchar(50);
ALTER TABLE OSSYS_PARAMETER ADD HOST_SERIAL nvarchar(50);

ALTER TABLE OSSYS_ESPACE_VERSION ADD HAS_HTTPSCLIENTCERTIFICATES tinyint(1);

CREATE TABLE OSSYS_DBCATALOG(ID integer NOT NULL auto_increment, NAME nvarchar(50) NOT NULL , USERNAME nvarchar(50) NOT NULL, PASSWORD nvarchar(50) NOT NULL, LOGICAL_NAME nvarchar(50) NOT NULL, OWNERUSERNAME nvarchar(50), OWNERPASSWORD nvarchar(50), DATATABLESPACE nvarchar(50), INDEXTABLESPACE nvarchar(50), primary key(ID)); 

ALTER TABLE OSSYS_ESPACE ADD DBCATALOG_ID integer NULL;
ALTER TABLE OSSYS_ESPACE_VERSION ADD DBCATALOG_ID integer NULL;

ALTER TABLE OSSYS_SITE_PROPERTY ADD USER_MODIFIED tinyint(1) DEFAULT 0;


ALTER TABLE OSSYS_ESPACE_VERSION DROP COLUMN HAS_MOBILEWEB;
ALTER TABLE OSSYS_REPORT_ESPACEUSA DROP COLUMN SLOWWAPHITS;
ALTER TABLE OSSYS_REPORT_ESPACEUSA DROP COLUMN WAPHITS;
ALTER TABLE OSSYS_REPORT_ESPACEUSA DROP COLUMN WAPMSISDN;
ALTER TABLE OSSYS_REPORT_HOURLYUSA DROP COLUMN SLOWWAPSCREENS;
ALTER TABLE OSSYS_REPORT_HOURLYUSA DROP COLUMN WAPHITS;

CREATE TABLE OSSYS_GROUP (ID integer NOT NULL auto_increment, NAME nvarchar(100) ,DESCRIPTION nvarchar(500)  , CREATED_BY integer, CREATED datetime, primary key(ID));
CREATE TABLE OSSYS_GROUP_ROLE (ID integer NOT NULL auto_increment, GROUP_ID integer, ROLE_ID integer, primary key(ID));
CREATE TABLE OSSYS_GROUP_USER (ID integer NOT NULL auto_increment, GROUP_ID integer, USER_ID integer, primary key(ID));

INSERT INTO OSSYS_PARAMETER (name,Val) values('OutSystems.HubEdition.SerialCalculationMethod','hash');

CREATE VIEW OSSYS_PERMISSION_AREA AS SELECT ID, ESPACE_ID, SS_KEY, NAME, DESCRIPTION, PERSISTENT, IS_ACTIVE FROM OSSYS_ROLE;
CREATE VIEW OSSYS_USER_PERMISSION AS SELECT ID, USER_ID, ROLE_ID PERMISSION_AREA_ID, TENANT_ID FROM OSSYS_USER_ROLE;

ALTER TABLE OSSYS_ESPACE_VERSION ADD ESPACE_NAME VARCHAR (35) NULL;
ALTER TABLE OSSYS_ESPACE ADD PENDING_VERSION_ID integer NULL;

ALTER TABLE OSSYS_REPORT_SU ADD HMAC varchar(50) NULL ;
ALTER TABLE OSSYS_REPORT_SU ADD LASTUPDATEDATE datetime NULL ;
ALTER TABLE OSSYS_ESPACE_VERSION ADD OMLHASH VARCHAR (50) NULL;
ALTER TABLE OSSYS_ACTIVATION ADD HMAC VARCHAR (50) NULL;

CREATE TABLE OSSYS_PRODUCT (ID integer NOT NULL auto_increment, PRODUCT_ID nvarchar(50), NAME nvarchar(250), DESCRIPTION longtext, LICENSE_TERM_DATE datetime, LICENSE blob, HMAC nvarchar(50), HMACVERSION nvarchar(50), LICENSE_ACTIVATION_CODE nvarchar(40), primary key(ID) );
CREATE TABLE OSSYS_ESPACE_PRODUCTINFO ( ESPACEID integer NOT NULL, PRODUCT_ID nvarchar(50), PRODUCT_NAME nvarchar(250), IS_OPEN_SOURCE tinyint(1), LASTUPDATEDATE datetime, HMAC nvarchar(50), HMACVERSION nvarchar(50)) ;

ALTER TABLE OSSYS_DBCATALOG ADD USEINTEGRATEDAUTH tinyint(1) DEFAULT 0 NOT NULL;

CREATE TABLE OSSYS_MODULE_PUBLICELEMENT (ID integer NOT NULL auto_increment, NAME nvarchar(50), KIND nvarchar(20), SS_KEY nvarchar(100), PRODUCER_NAME nvarchar(50), PRODUCER_KIND nvarchar(20), PRODUCER_SS_KEY nvarchar(100), PUBLISHED_PROD_VERSION_ID integer, COMPATIBILITY_SIGNATURE_HASH nvarchar(50), FULL_SIGNATURE_HASH nvarchar(50), primary key(ID)) ;

ALTER TABLE OSSYS_ESPACE_REFERENCE ADD COMPATIBILITY_SIGNATURE_HASH VARCHAR (50) NULL;
ALTER TABLE OSSYS_ESPACE_REFERENCE ADD FULL_SIGNATURE_HASH VARCHAR (50) NULL;
ALTER TABLE OSSYS_ACTIVATION ADD HMACVERSION VARCHAR(50) NULL ;
ALTER TABLE OSSYS_ESPACE_VERSION ADD OMLHASHVERSION varchar(50) NULL ;
ALTER TABLE OSSYS_ESPACE_VERSION ADD HMAC varchar(50) NULL ;
ALTER TABLE OSSYS_ESPACE_VERSION ADD HMACVERSION varchar(50) NULL ;
ALTER TABLE OSSYS_ESPACE_VERSION ADD LASTUPDATEDATE datetime NULL ;
ALTER TABLE OSSYS_EXTENSION_VERSION ADD HMACVERSION varchar(50) NULL ;

ALTER TABLE OSSYS_REPORT_SU ADD HMACVERSION varchar(50) NULL;
ALTER TABLE OSSYS_ESPACE ADD HMAC varchar(50) NULL ;
ALTER TABLE OSSYS_ESPACE ADD HMACVERSION varchar(50) NULL ;

CREATE VIEW ossys_Espace_Tenant AS SELECT oe1.ID ESPACE_ID, ot.ID TENANT_ID, ot.NAME TENANT_NAME, ot.IS_ACTIVE FROM OSSYS_TENANT ot INNER JOIN OSSYS_ESPACE oe ON ot.ESPACE_ID=oe.ID AND oe.IS_ACTIVE=1 INNER JOIN OSSYS_ESPACE oe1 ON (oe1.USER_PROVIDER_KEY=oe.SS_KEY AND oe1.IS_ACTIVE=1) OR (oe.ID=oe1.ID AND COALESCE(oe1.USER_PROVIDER_KEY, ' ') = ' ');
CREATE TABLE OSSYS_SITE_PROPERTY_SHARED(SITE_PROPERTY_DEFINITION_ID integer NOT NULL, PROPERTY_VALUE nvarchar (2000) NOT NULL, USER_MODIFIED tinyint(1) default 0) ;
ALTER TABLE OSSYS_SITE_PROPERTY_DEFINITION ADD IS_SHARED tinyint(1) default 0 NOT NULL;
CREATE TABLE OSSYS_CYCLIC_JOB_SHARED(META_CYCLIC_JOB_ID integer NOT NULL,SCHEDULE nvarchar (2000) ,LAST_RUN datetime ,NEXT_RUN datetime ,LAST_DURATION integer ,IS_RUNNING_SINCE datetime ,IS_RUNNING_BY nvarchar (50), NUMBER_OF_TRIES integer default 0) ;
ALTER TABLE OSSYS_META_CYCLIC_JOB ADD IS_SHARED tinyint(1) default 0 NOT NULL;

ALTER TABLE OSSYS_GROUP_ROLE ADD TENANT_ID integer default 0 NOT NULL;
ALTER TABLE OSSYS_GROUP_USER ADD TENANT_ID integer default 0 NOT NULL;
CREATE VIEW OSSYS_USER_EFFECTIVE_ROLE AS SELECT Role_Id, User_Id, Tenant_Id FROM ossys_User_Role UNION SELECT Role_Id, User_Id, gr.Tenant_Id FROM ossys_Group_Role gr JOIN ossys_Group_User gu ON gr.Group_Id = gu.Group_Id AND gr.Tenant_Id = gu.Tenant_Id;

GO

CREATE FUNCTION CheckRole (RoleId integer, UserId integer) RETURNS integer
begin
declare result integer;
SELECT COUNT(1) INTO result FROM ossys_User_Role u inner join OSSYS_USER on u.USER_ID = OSSYS_USER.ID and u.Tenant_Id = ossys_User.Tenant_Id WHERE u.User_Id=UserId AND u.Role_Id=RoleId and OSSYS_USER.IS_ACTIVE=1;
if result > 0 then return 1;
end if;
SELECT COUNT(1) INTO result FROM ossys_Group_Role r JOIN ossys_Group_User u ON r.Group_Id=u.Group_Id and r.Tenant_Id=u.Tenant_Id inner join OSSYS_USER on u.USER_ID = OSSYS_USER.ID and u.Tenant_Id = OSSYS_USER.Tenant_Id WHERE u.User_Id=UserId AND r.Role_Id=RoleId and OSSYS_USER.IS_ACTIVE=1;
IF result > 0 THEN RETURN 1;
else return 0;
end if;
end;

GO

CREATE TABLE OSSYS_TENANT_VIEW(TENANT_ID integer NOT NULL, ENTITY_KEY nvarchar (50) NOT NULL, ESPACE_ID integer NOT NULL) ;
CREATE TABLE OSSYS_ESPACE_RUNTIME(ID integer NOT NULL auto_increment, ESPACE_ID integer DEFAULT NULL, BROKEN_REFERENCES integer DEFAULT 0, OUTDATED_REFERENCES integer DEFAULT 0, MISSING_REFERENCES integer DEFAULT 0, OUTDATED_MISSING_REFERENCES integer DEFAULT 0, OLDPRODUCER_REFERENCES integer DEFAULT 0, UNASSIGNED_PHONES tinyint(1) DEFAULT 0, REQUIRES_COMPILATION tinyint(1) DEFAULT 0, DISABLED tinyint(1) DEFAULT 0, USERPROVIDER_VERSION_ID integer DEFAULT NULL, OUTDATED_USERPROVIDER tinyint(1) DEFAULT 0, MISSING_USERPROVIDER tinyint(1) DEFAULT 0, OLDPRODUCER_USERPROVIDER tinyint(1) DEFAULT 0, primary key(ID)) ;

GO

ALTER TABLE OSSYS_ESPACE_VERSION ADD DIRECT_UPGRADE_FROM_HASH varchar(50) NULL ;
ALTER TABLE OSSYS_EXTENSION_VERSION ADD DIRECT_UPGRADE_FROM_HASH varchar(50) NULL ;

ALTER TABLE OSSYS_GROUP ADD TENANT_ID integer default 0 NOT NULL;
UPDATE OSSYS_PARAMETER SET Name='PlatformServices.DebugMode' WHERE Name='PlatformServicesDebug' ;

ALTER TABLE OSSYS_ESPACE_VERSION ADD GENERALHASH varchar(100) NULL ;
ALTER TABLE OSSYS_EXTENSION_DEPENDENCY ADD EXTENSION_VERSION_ID integer;
ALTER TABLE OSSYS_WEB_SERVICE ADD COMPATIBILITY_MODE tinyint(1) DEFAULT 0;


CREATE VIEW OSLOG_SCREEN_PREVIOUS AS SELECT * FROM OSLOG_SCREEN_9;
CREATE VIEW OSLOG_ERROR_PREVIOUS AS SELECT * FROM OSLOG_ERROR_9;
CREATE VIEW OSLOG_SMS_PREVIOUS AS SELECT * FROM OSLOG_SMS_9;
CREATE VIEW OSLOG_CYCLIC_JOB_PREVIOUS AS SELECT * FROM OSLOG_CYCLIC_JOB_9;
CREATE VIEW OSLOG_GENERAL_PREVIOUS AS SELECT * FROM OSLOG_GENERAL_9;
CREATE VIEW OSLOG_WEB_SERVICE_PREVIOUS AS SELECT * FROM OSLOG_WEB_SERVICE_9;
CREATE VIEW OSLOG_WEB_REFERENCE_PREVIOUS AS SELECT * FROM OSLOG_WEB_REFERENCE_9;
CREATE VIEW OSLOG_EXTENSION_PREVIOUS AS SELECT * FROM OSLOG_EXTENSION_9;

ALTER TABLE OSSYS_ESPACE_VERSION ADD JQUERYVERSION nvarchar(15) ;

UPDATE OSSYS_PARAMETER SET Val = 'http://hubedition.outsystems.net/issues/outsystems/Issues.asmx' WHERE name='submitseviceurl';

insert into OSSYS_PARAMETER (VAl, NAME) values('8.9.5.1', 'lastupgradeversion');

-- %VERSION_UPGRADE% = "8.9.5.8"
-- %TABLE_NOT_EXISTS% = "OSSYS_ESPACE_VERSION_ICON"
CREATE TABLE OSSYS_ESPACE_VERSION_ICON (ID integer NOT NULL, CONTENT_HASH nvarchar(50) DEFAULT '', CONTENT BLOB NULL);

GO

UPDATE OSSYS_PARAMETER SET Val='8.9.5.7' WHERE name='lastupgradeversion'; 

GO

-- %VERSION_UPGRADE% = "8.9.5.9" 
-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_0"
CREATE TABLE OSLOG_INTEGRATION_0(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_0 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_1"
CREATE TABLE OSLOG_INTEGRATION_1(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_1 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_2"
CREATE TABLE OSLOG_INTEGRATION_2(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_2 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO
-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_3"
CREATE TABLE OSLOG_INTEGRATION_3(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_3 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_4"
CREATE TABLE OSLOG_INTEGRATION_4(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_4 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_5"
CREATE TABLE OSLOG_INTEGRATION_5(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_5 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_6"
CREATE TABLE OSLOG_INTEGRATION_6(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_6 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_7"
CREATE TABLE OSLOG_INTEGRATION_7(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_7 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_8"
CREATE TABLE OSLOG_INTEGRATION_8(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_8 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_INTEGRATION_9"
CREATE TABLE OSLOG_INTEGRATION_9(ID nvarchar(50) NOT NULL, INSTANT datetime NOT NULL, SESSION_ID nvarchar(50) NOT NULL, USER_ID integer NOT NULL, ESPACE_ID integer NOT NULL, TENANT_ID integer, ERROR_ID nvarchar(50), MODULE_NAME nvarchar(15), MESSAGE_TYPE nvarchar(10), EXECUTED_BY nvarchar(50), CYCLE integer NOT NULL, MESSAGE longtext, primary key(ID));
CREATE INDEX IDX_OSLOG_INT_ESPACE_ID_9 ON OSLOG_INTEGRATION_0( Instant,Espace_Id );
GO

-- %END_IGNORING_BLOCK%
CREATE OR REPLACE VIEW OSLOG_INTEGRATION AS SELECT * FROM OSLOG_INTEGRATION_0;
CREATE OR REPLACE VIEW OSLOG_INTEGRATION_PREVIOUS AS SELECT * FROM OSLOG_INTEGRATION_9;

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_0.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_0 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_1.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_1 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_2.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_2 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_3.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_3 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_4.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_4 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_5.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_5 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_6.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_6 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_7.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_7 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_8.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_8 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_WEB_REFERENCE_9.INTEGRATIONLOG_ID"
ALTER TABLE OSLOG_WEB_REFERENCE_9 ADD INTEGRATIONLOG_ID nvarchar(50);
GO

-- %END_IGNORING_BLOCK%
GO

-- %VERSION_UPGRADE% = "8.9.5.15" 
UPDATE OSSYS_PARAMETER SET Val='8.9.5.8' WHERE name='lastupgradeversion'; 

GO
-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_0.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_0 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_1.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_1 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_2.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_2 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_3.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_3 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_4.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_4 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO
-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_5.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_5 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_6.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_6 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_7.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_7 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_8.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_8 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %COLUMN_NOT_EXISTS% = "OSLOG_ERROR_9.ENVIRONMENTINFORMATION"
ALTER TABLE OSLOG_ERROR_9 ADD ( ENVIRONMENTINFORMATION nvarchar(2000) NULL );

GO

-- %END_IGNORING_BLOCK%
ALTER TABLE OSLOG_ERROR_0 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_1 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_2 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_3 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_4 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_5 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_6 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_7 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_8 MODIFY STACK nvarchar(2000) NULL ;
ALTER TABLE OSLOG_ERROR_9 MODIFY STACK nvarchar(2000) NULL ;
GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_0"
CREATE TABLE OSLOG_ERROR_DETAIL_0(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_1"
CREATE TABLE OSLOG_ERROR_DETAIL_1(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_2"
CREATE TABLE OSLOG_ERROR_DETAIL_2(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_3"
CREATE TABLE OSLOG_ERROR_DETAIL_3(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_4"
CREATE TABLE OSLOG_ERROR_DETAIL_4(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_5"
CREATE TABLE OSLOG_ERROR_DETAIL_5(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_6"
CREATE TABLE OSLOG_ERROR_DETAIL_6(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_7"
CREATE TABLE OSLOG_ERROR_DETAIL_7(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_8"
CREATE TABLE OSLOG_ERROR_DETAIL_8(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %TABLE_NOT_EXISTS% = "OSLOG_ERROR_DETAIL_9"
CREATE TABLE OSLOG_ERROR_DETAIL_9(ID nvarchar (50) NOT NULL, FULLSTACKTRACE longtext NOT NULL);

GO

-- %END_IGNORING_BLOCK%

CREATE OR REPLACE VIEW OSLOG_ERROR AS SELECT  error.Id, error.Instant, error.Session_Id, error.user_id, error.Espace_Id, error.Tenant_Id, error.Message, coalesce(errorDetail.FullStackTrace, error.Stack) as Stack, error.Module_Name, error.Server, error.Cycle, error.EnvironmentInformation FROM oslog_Error_0 error LEFT OUTER JOIN oslog_Error_DETAIL_0 errorDetail ON error.Id = errorDetail.Id;

GO

CREATE OR REPLACE VIEW OSLOG_ERROR_PREVIOUS AS SELECT  error.Id, error.Instant, error.Session_Id, error.user_id, error.Espace_Id, error.Tenant_Id, error.Message, coalesce(errorDetail.FullStackTrace, error.Stack) as Stack, error.Module_Name, error.Server, error.Cycle, error.EnvironmentInformation FROM oslog_Error_9 error LEFT OUTER JOIN oslog_Error_DETAIL_9 errorDetail ON error.Id = errorDetail.Id;

GO
insert into OSSYS_PARAMETER(name,val) values ('OutSystems.HubEdition.Log.SupportBulkLogs', 'False');
GO

-- %VERSION_UPGRADE% = "8.9.5.15" 
DROP PROCEDURE IF EXISTS DEQUEUE_OSSYS_EMAIL_STATUS_V2;

GO

CREATE PROCEDURE `DEQUEUE_OSSYS_EMAIL_STATUS_V2`(in BatchSize integer, in Ip nvarchar(50), in NullDate datetime, in RecoverIntervalInMins integer)
begin
	declare v_id integer;
	declare done integer default false;

	declare MessageCursor cursor  FOR 
        SELECT ID
        FROM OSSYS_EMAIL_STATUS
        WHERE (IS_RUNNING_SINCE IS NULL OR IS_RUNNING_SINCE = NullDate OR (TIMESTAMPDIFF(SECOND, IS_RUNNING_SINCE, now()) * 60) >= RecoverIntervalInMins)
              AND NEXT_RUN <= now() AND NEXT_RUN IS NOT NULL
        ORDER BY Next_Run ASC
		LIMIT BatchSize
		FOR UPDATE;
	declare continue handler for not found set done = true;

	create temporary table email_queue (id integer);
	
	open MessageCursor;

	read_loop: LOOP
    FETCH MessageCursor INTO v_id;
    IF done THEN
      LEAVE read_loop;
    END IF;
	insert into email_queue (id) values (v_id);	
  END LOOP;
  
    UPDATE OSSYS_EMAIL_STATUS SET IS_RUNNING_SINCE = now()
    WHERE OSSYS_EMAIL_STATUS.ID IN (SELECT ID FROM email_queue);
	
	SELECT id from email_queue;

	drop temporary table if exists email_queue;
	
  CLOSE MessageCursor;
END;

GO
DROP PROCEDURE IF EXISTS DEQUEUE_OSSYS_EVENT;

GO

CREATE PROCEDURE DEQUEUE_OSSYS_EVENT(in BatchSize integer, in Ip nvarchar(50), in NullDate datetime, in ActivityId integer)
begin
	declare v_id integer;
	declare v_espace_id integer;
	declare v_tenant_id integer;
	declare v_activity_id integer;
	declare v_process_def_id integer;
	declare v_data_id integer;
	declare v_enqueue_time datetime;
	declare v_next_run datetime;
	declare done integer default false;

	
	declare MessageCursor cursor for 
        SELECT ID, ESPACE_ID, TENANT_ID, ACTIVITY_ID, PROCESS_DEF_ID, DATA_ID, ENQUEUE_TIME, NEXT_RUN
        FROM OSSYS_BPM_EVENT_QUEUE
        WHERE DEQUEUE_TIME IS NULL 
              AND NEXT_RUN <= now()
              AND OSSYS_BPM_EVENT_QUEUE.ID IN (SELECT q.ID
                                               FROM OSSYS_BPM_EVENT_QUEUE q
                                               INNER JOIN OSSYS_ESPACE espace ON q.ESPACE_ID = espace.ID AND espace.IS_ACTIVE = 1 AND espace.IS_LOCKED = 0
                                               LEFT JOIN OSSYS_ESPACE_RUNTIME runtime ON runtime.ESPACE_ID = q.ESPACE_ID
                                               LEFT JOIN OSSYS_TENANT tenant ON q.TENANT_ID = tenant.Id
                                               LEFT JOIN OSSYS_BPM_ACTIVITY act ON q.ACTIVITY_ID = act.Id
                                               LEFT JOIN OSSYS_BPM_PROCESS process ON act.PROCESS_ID = process.Id
                                               INNER JOIN OSSYS_BPM_PROCESS_DEFINITION processDef ON (process.PROCESS_DEF_ID = processDef.ID OR q.PROCESS_DEF_ID = processDef.ID) AND processDef.IS_LOCKED = 0 AND processDef.IS_ACTIVE = 1
                                               WHERE (runtime.Id IS NULL OR runtime.Disabled = 0) 
                                               		 AND (tenant.ID IS NULL OR tenant.IS_ACTIVE = 1)
                                                     AND (espace.ZONE_ID IS NULL OR Ip = '' OR espace.ZONE_ID IN (SELECT OSSYS_ZONE_SERVER.ZONE_ID from OSSYS_ZONE_SERVER JOIN OSSYS_SERVER on OSSYS_ZONE_SERVER.SERVER_ID = OSSYS_SERVER.ID and OSSYS_SERVER.IP_ADDRESS = Ip))
                                                     AND (act.ID IS NULL OR ((act.IS_RUNNING_SINCE IS NULL Or act.IS_RUNNING_SINCE = NullDate) AND process.STATUS_ID = 1))
                                              )
              AND (ActivityId = 0 OR ACTIVITY_ID = ActivityId)
        ORDER BY NEXT_RUN ASC
		LIMIT BatchSize
        FOR UPDATE;


	declare continue handler for not found set done = true;

	drop temporary table if exists event_queue;
	create temporary table event_queue (id integer, espace_id integer, tenant_id integer, activity_id integer, process_def_id integer, data_id integer, enqueue_time datetime, next_run datetime);

    open MessageCursor;
	read_loop: LOOP
	FETCH MessageCursor INTO v_id, v_espace_id,  v_tenant_id, v_activity_id, v_process_def_id,  v_data_id, v_enqueue_time, v_next_run;

    IF done THEN
      LEAVE read_loop;
    END IF;

	insert into event_queue (id, espace_id, tenant_id, activity_id, process_def_id, data_id, enqueue_time, next_run)
	values (v_id, v_espace_id, v_tenant_id, v_activity_id, v_process_def_id,  v_data_id, v_enqueue_time, v_next_run);

    END LOOP;
    CLOSE MessageCursor;

    UPDATE OSSYS_BPM_EVENT_QUEUE SET DEQUEUE_TIME = now()
    WHERE OSSYS_BPM_EVENT_QUEUE.ID IN (SELECT ID FROM event_queue);

	
	SELECT t.ID, 
		   t.ESPACE_ID,
		   COALESCE(act.Tenant_Id, t.Tenant_Id) TENANT_ID,
		   t.ACTIVITY_ID,
		   act.PROCESS_ID,
		   t.PROCESS_DEF_ID,
		   t.DATA_ID DATA_ID,
		   round(timestampdiff(DAY, t.ENQUEUE_TIME, now())) DAYS_SINCE_QUEUED, 
		   espace.NAME ESPACE_NAME,
		   espace.IS_MULTITENANT,
		   tenant.NAME TENANT_NAME,
		   act_def.ss_key ACTIVITY_KEY,
		   pdef.ss_key PROCESS_DEF_KEY,
		   (SELECT 1 FROM DUAL
			WHERE act.Tenant_Id IS NOT NULL OR t.Tenant_Id IS NULL OR (t.Tenant_Id IS NOT NULL AND
			  EXISTS(SELECT 1 from ossys_espace_tenant et
					 WHERE et.Espace_Id = espace.id and et.Tenant_Id = t.Tenant_Id))) VALID_TENANT
        FROM event_queue t
             INNER JOIN OSSYS_ESPACE espace ON t.ESPACE_ID = espace.ID
             LEFT JOIN OSSYS_TENANT tenant ON t.TENANT_ID = tenant.ID
             LEFT JOIN OSSYS_BPM_ACTIVITY act ON t.Activity_Id = act.ID
             LEFT JOIN OSSYS_BPM_ACTIVITY_DEFINITION act_def ON act.ACTIVITY_DEF_ID = act_def.ID
             LEFT JOIN OSSYS_BPM_PROCESS_DEFINITION pdef ON t.PROCESS_DEF_ID = pdef.ID;
			 
	drop temporary table if exists event_queue;
END;

GO

drop function if exists GetPrecedentActivityId;

GO

create function GetPrecedentActivityId(startId integer, targetKey nvarchar(40), recursionLimit integer) returns integer
begin
declare v_precedent_id integer;
declare v_def_key nvarchar(40);
declare v_count integer default 0;

recursion: loop

	SELECT PRECEDENT.ID, D.SS_KEY into v_precedent_id, v_def_key
	FROM OSSYS_BPM_ACTIVITY ACT
	INNER JOIN OSSYS_BPM_ACTIVITY PRECEDENT ON PRECEDENT.ID = ACT.PRECEDENT_ACTIVITY_ID
	INNER JOIN OSSYS_BPM_ACTIVITY_DEFINITION D ON D.ID = PRECEDENT.ACTIVITY_DEF_ID
	WHERE ACT.ID = startId;

	if strcmp(targetKey, v_def_key) = 0 then
		leave recursion;
	elseif v_count  >= recursionLimit or found_rows() = 0 then
		begin
			set v_precedent_id = 0;
			leave recursion;
		end;
	end if;

	set v_count = v_count + 1;
	set startId = v_precedent_id;
	iterate recursion;

	end loop;

return v_precedent_id;
end;

GO

CREATE TABLE OSSYS_ESPACE_OBJECT_COUNT(ID int not null auto_increment, ESPACE_VERSION_ID int not null, OBJ_KIND NVARCHAR(50) not null, OBJ_COUNT int not null, primary key(ID));

GO

-- %VERSION_UPGRADE% = "8.9.5.29" 
UPDATE OSSYS_PARAMETER SET Val='8.9.5.29' WHERE name='lastupgradeversion'; 

GO

-- %VERSION_UPGRADE% = "9.0.0.0" 
UPDATE OSSYS_PARAMETER SET Val='9.0.0.0' WHERE name='lastupgradeversion' 
GO
-- %VERSION_UPGRADE% = "9.0.0.1" 
UPDATE OSSYS_PARAMETER SET Val='9.0.0.1' WHERE name='lastupgradeversion' 
GO

-- %VERSION_UPGRADE% = "9.0.0.4" 
delete from OSSYS_PARAMETER WHERE `name`='OutSystems.HubEdition.Log.SupportBulkLogs'; 
GO
 
-- %TOUCH_VERSION% = "..."
insert into ossys_parameter(name,val) values ('version', '9.0.0.6');
insert into oslog_parameter(name,val) values ('version', '9.0.0.6');
COMMIT;
GO
